/* fxsp2lib.c */

#include <stdlib.h>
#include <stdio.h>


typedef struct {
	signed short vx;	/* ΍Wf[^ */
	signed short vy;	/* ΍Wf[^ */
	unsigned short pt;	/* XvCgp^[mD */
	unsigned short rv;	/* ]R[h */
} SP_WORK;

static FILE *fp;
static int pattern_no;
static int sprite_no;
extern char n_option;


short fxsp_on (void)
{
	if (n_option)
		return (0);

	if ((fp = fopen ("temp001.obj", "wb")) == NULL) {
		printf ("t@C߂܂\n");
		return (-1);
	}
	fprintf (fp, "\nPCG_FILE	=	***.sp	256	* gp PCG f[^\n"
		 "\n"
		 "XY_OFFSET	=	$0000	$0000	* W̃ItZbg\n"
		 "PT_OFFSET	=	$0000		* obfp^[io[̃ItZbg\n"
		 "OBJ_RV		=	$0000		* Ŝ̔]R[h\n"
		 "\n");
	pattern_no = 0;
	sprite_no = 0;
	return (0);
}



static void write_pos (signed short pos)
{
	signed short p = pos;

	if (n_option)
		return;

	if (p < 0)
		fprintf (fp, "-$%04hx	", -p);
	else
		fprintf (fp, " $%04hx	", p);

	return;
}



/* xsp_set_st ƒuĎgƈ̍\̂ .obj t@Cɏo */
short fxsp_set_st (void *sp_work0)
{
	SP_WORK *sp_work = (SP_WORK *) sp_work0;

	if (n_option)
		return (0);

	if (!sprite_no) {
		fprintf (fp,
			 "******************************** XvCgp^[ %3d ****\n\n"
			 "No.	=	NEXT	* XvCg̃p^[io[\n"
			 "			* 珇ɁAX Y PT RV iȉlj\n"
			 ,pattern_no);
	}
	fprintf (fp, "	");
	write_pos (sp_work->vx);
	write_pos (sp_work->vy);

	fprintf (fp, "$%04x	", sp_work->pt);
	fprintf (fp, "$%04x\n", sp_work->rv);
	sprite_no++;

	return (0);
}



short fxsp_out (void)
{
	short s = sprite_no;

	if (n_option)
		return (0);

	fprintf (fp, "\n\n");
	pattern_no++;
	sprite_no = 0;

	return (s);
}



short fxsp_off (void)
{
	if (n_option)
		return (0);

	if (fp != NULL)
		fclose (fp);
	fp = NULL;

	return (0);
}
